BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}



Name:           dbunit
Summary:        DBUnit extension for JUnit
Url:            http://dbunit.sourceforge.net/
Version:        2.1
Release:        alt2_4jpp1.7
Epoch:          0
License:        LGPL
Group:          Development/Java
%if ! %{gcj_support}
BuildArch:      noarch
%endif
Source0:        %{name}-%{version}-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        dbunit-2.1-jpp-depmap.xml
Patch0:         dbunit-2.1-build_xml.patch
#Patch1:         dbunit-2.1-project_xml.patch

%if %{with_maven}
BuildRequires: maven-plugins
BuildRequires: saxon
BuildRequires: saxon-scripts
%endif
BuildRequires: ant
BuildRequires: jakarta-crimson
BuildRequires: hsqldb
BuildRequires: jdbc-stdext
BuildRequires: junit
BuildRequires: mockmaker
BuildRequires: mockobjects
BuildRequires: mockobjects-jdk1.4
BuildRequires: jakarta-poi
Requires: ant
Requires: jdbc-stdext
Requires: junit
Requires: jakarta-poi
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
DbUnit is a JUnit extension (also usable with Ant) targeted 
for database-driven projects that, among other things, puts 
your database into a known state between test runs. This is 
an excellent way to avoid the myriad of problems that can 
occur when one test case corrupts the database and causes 
subsequent tests to fail or exacerbate the damage. 
DbUnit has the ability to export and import your database 
data to and from XML datasets. Since version 2.0, DbUnit can 
works with very large dataset when use in streaming mode. 
DbUnit can also helps you to verify that your database data 
match expected set of values. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}-%{version}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;

%patch0 -b .sav
#%patch1 -b .sav

%build
%if %{with_maven}
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

# A couple of items are not in maven repos and we need to put them 
# in the local one manually 

mkdir -p $MAVEN_HOME_LOCAL/repository/JPP/jars
(cd $MAVEN_HOME_LOCAL/repository/JPP/jars
        ln -s $(build-classpath mockobjects) .
        ln -s $(build-classpath jdbc-stdext) .
)

maven -e \
    -Dmaven.repo.remote=file:/usr/share/maven/repository \
    -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
    jar javadoc
%else
export CLASSPATH=$(build-classpath crimson hsqldb poi mockobjects-core mockobjects mockmaker jdbc-stdext):target/classes:target/test-classes
ant -Dbuild.sysclasspath=only jar javadoc
%endif

%install
%__rm -rf %{buildroot}

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc LICENSE.txt
%{_javadir}/*
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Nov 14 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt2_4jpp1.7
- build with maven

* Fri Aug 10 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt1_4jpp1.7
- converted from JPackage by jppimport script

